#include <stdio.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <string.h>
#include <stdlib.h>
#include <netdb.h>
#include <unistd.h>

void usage(void);
char *lookup(struct in_addr addr);

int main(int ac, char **av)
{
  int sock;
  int sock2;
  int len;
  struct sockaddr_in addr;
  char buffer; /* 1 char only */  

  if (ac != 2)
    usage();
  
  sock = socket(AF_INET, SOCK_STREAM, 0);
  if (sock < 0)
    {
      perror("socket");
      exit(1);
    }
  
  addr.sin_addr.s_addr = INADDR_ANY;
  addr.sin_family = AF_INET;
  addr.sin_port = htons(strtol(av[1],NULL,0));
  
  if (bind(sock, (struct sockaddr *)&addr, sizeof(addr)) == -1)
    {
      perror("bind");
      exit(1);
    }

  if (listen(sock, 1) == -1)
    {
      perror("listen");
      exit(1);
    }

  while (1)
    {
      fprintf(stderr, "\nListening on port %lu\n", strtol(av[1],NULL,0));
      fflush(stdout);

      len = sizeof(addr);
      sock2 = accept(sock, (struct sockaddr *)&addr, &len);
      
      fprintf(stderr, "Connect from : %s\n", lookup(addr.sin_addr));
            
      while (1)
	{
	  int status;
	  
	  status = recv(sock2, (char *)&buffer, 1, 0);
	  if (status > 0)
	    {
	      printf("%c", buffer);
	      fflush(stdout);
	    }
	  else
	    if (status <= 0)
	      {
		fprintf(stderr, "Connection closed.\n");
		close(sock2);
		break;
	      }
	}
    }

  return 0;
}

void usage(void)
{
  fprintf(stderr, "Portdump v.0.01b\n\n");
  fprintf(stderr, "Syntax:\n");
  fprintf(stderr, "dumpport portnr\n");

  exit(1);
}

char *lookup(struct in_addr temp)
{
  struct hostent *he;

  he = gethostbyaddr((char *)&temp, sizeof(temp), 0);
  if (!he)
    return inet_ntoa(temp);
  else
    return he->h_name;
}
